/**
 * This file was generated by the Objective Systems XBinder(tm) Compiler
 * (http://www.obj-sys.com).  Version: 1.1-Beta1, Date: 11-Nov-2004.
 * Copyright (c) 2003-2006 Objective Systems, Inc.
 *
 * Permission is hereby granted to redistribute this file with the
 * condition that this copyright notice be present and not altered.
 */
#include <stdio.h>
#include <stdlib.h>
#include "client.h"
#include "streams.h"

static OSBOOL gs_trace = TRUE;

int main (int argc, char** argv)
{
   XMPPC_message_ELEM message;
   XMPPC_message_ELEM_1* pBodyPart;
   OSCTXT       ctxt;
   int          i, stat;
   const char*  filename = "message.xml";
   OSBOOL       verbose = FALSE;
   const OSOCTET* pMsgBuf;

   /* Process command line arguments */

   if (argc > 1) {
      for (i = 1; i < argc; i++) {
         if (!strcmp (argv[i], "-v")) verbose = TRUE;
         else if (!strcmp (argv[i], "-o")) filename = argv[++i];
         else if (!strcmp (argv[i], "-notrace")) gs_trace = FALSE;
         else {
            printf ("usage: writer [-v] [-o <filename>] [-notrace]\n");
            printf ("   -v  verbose mode: print trace info\n");
            printf ("   -o <filename>  write encoded msg to <filename>\n");
            printf ("   -notrace  do not display trace info\n");
            return 0;
         }
      }
   }

   /* Init context */

   stat = rtXmlInitContext (&ctxt);
   if (0 != stat) {
      printf ("Context initialization failed.\n");
      rtxErrPrint (&ctxt);
      return stat;
   }

   if (verbose) rtxSetDiag (&ctxt, 1);

   /* Populate structure of generated type */

   Init_XMPPC_message_ELEM (&ctxt, &message);
   
   message.m.fromPresent = TRUE;
   message.from.value = (const OSUTF8CHAR*)"juliet@example.com";
   message.m.toPresent = TRUE;
   message.to.value = (const OSUTF8CHAR*)"romeo@example.com";
   message.m.langPresent = TRUE;
   message.lang.value = (const OSUTF8CHAR*)"en";
   pBodyPart = rtxMemAllocType (&ctxt, XMPPC_message_ELEM_1);
   Init_XMPPC_message_ELEM_1 (&ctxt, pBodyPart);
   pBodyPart->t = T_XMPPC_message_ELEM_1_XMPPC_body;
   pBodyPart->u.XMPPC_body._base.value = (const OSUTF8CHAR*)
      "Art thou not Romeo, and a Montague?";
   rtxDListAppend (&ctxt, &message._choice1, pBodyPart);

   /* Encode */

   stat = rtXmlSetEncBufPtr (&ctxt, 0, 0);

   if (0 == stat)
      stat = XmlE_XMPPC_message (&ctxt, &message);

   if (0 == stat) {
      pMsgBuf = rtXmlGetEncBufPtr (&ctxt);
      if (gs_trace) {
         printf ("encoded XML message:\n");
         puts ((char*)pMsgBuf);
         printf ("\n");
      }

      /* Write the encoded message out to the output file */

  stat = rtXmlWriteToFile (&ctxt, filename);
  if (0 != stat) {
     printf ("Write to file %s failed\n", filename);
     rtxErrPrint (&ctxt);
  } 
   }
   else if (gs_trace) {
      printf ("Encoding failed\n");
      rtxErrPrint (&ctxt);
   }

   rtxFreeContext (&ctxt);
   return stat;
}
