/**
 * This file was generated by the Objective Systems XBinder(tm) Compiler
 * (http://www.obj-sys.com).  Version: 2.2.A, Date: 20-May-2010.
 * Copyright (c) 2003-2018 Objective Systems, Inc.
 *
 * Permission is hereby granted to redistribute this file with the
 * condition that this copyright notice be present and not altered.
 */
#include <stdio.h>
#include <stdlib.h>
#include "rtxsrc/rtxMemLeakCheck.h"
#include "rtxsrc/rtxPrint.h"
#include "rtxsrc/rtxStreamFile.h"
#include "test.h"

int main (int argc, char** argv)
{
   MyType*      pdata;
   OSCTXT       ctxt;
   int          i, stat;
   const char*  filename = "message.json";
   OSRTDiagTraceLevel traceLevel = OSRTDiagError;

   DECLARE_MEMLEAK_DETECTOR;

   /* Process command line arguments */

   if (argc > 1) {
      for (i = 1; i < argc; i++) {
         if (!OSCRTLSTRCMP (argv[i], "-o")) filename = argv[++i];
         else if (!OSCRTLSTRCMP (argv[i], "-v")) traceLevel = OSRTDiagInfo;
         else if (!OSCRTLSTRCMP (argv[i], "-vv")) traceLevel = OSRTDiagDebug;
         else {
            printf ("usage: writer [options]\n");
            printf ("options:\n");
            printf ("   -v  verbose mode: print trace info\n");
            printf ("   -o <filename>  write encoded msg to <filename>\n");
            return 0;
         }
      }
   }

   /* Init context */

   stat = rtxInitContext (&ctxt);
   if (0 != stat) {
      printf ("Context initialization failed.\n");
      rtxErrPrint (&ctxt);
      return stat;
   }
   if (traceLevel > OSRTDiagError) {
      rtxDiagSetTraceLevel (&ctxt, traceLevel);
   }

   /* Populate structure of generated type */

   pdata = Test_rootNode (&ctxt);

   stat = rtxStreamFileCreateWriter (&ctxt, filename);

   if (0 == stat)
      stat = JsonEnc_rootNode (&ctxt, pdata);


   rtxStreamClose (&ctxt);

   if (0 == stat) {
      printf ("encoded message:\n");
      rtxPrintFile (filename);
      printf ("\n");
   }
   else {
      printf ("Encoding failed\n");
      rtxErrPrint (&ctxt);
   }

   rtxFreeContext (&ctxt);
   return stat;
}

MyType* Test_rootNode (OSCTXT* pctxt)
{
   MyType* pvalue = rtxMemAllocType (pctxt, MyType);
   Init_MyType (pctxt, pvalue);

   pvalue->c0.name.value = OSUTF8("pvalue->c0.name");
   pvalue->c0.name.cdata = FALSE;

   { static const OSOCTET testdata[] = {
   0x28, 0x75, 0x16, 0xc6, 0x44, 0x20, 0x50, 0x6e,
   0xc0, 0xd5, 0x83, 0x3e, 0xe8, 0xaa, 0xf3, 0x2b,
   0xcd, 0xc6, 0xc9, 0x19, 0xe8, 0x9f, 0x33, 0x11,
   0xb0, 0x54, 0xa7, 0xf6, 0x5e, 0x4d, 0x4d, 0xe9,
   0x8, 0x27, 0x95, 0x8f, 0xa5, 0xc, 0xf1, 0x71,
   0x31, 0x80, 0xd0, 0xa8, 0x5, 0x44, 0xb5, 0xf,
   0x14, 0xcc, 0xa9, 0x17, 0x27 };
   pvalue->c1.hexBinElem.numocts = 53;
   pvalue->c1.hexBinElem.data = (OSOCTET *)testdata;
   }

   { static const OSOCTET testdata[] = {
   0x83, 0xc9, 0x20, 0x45 };
   pvalue->c1.hexBinElem4.numocts = 4;
   OSCRTLMEMCPY (pvalue->c1.hexBinElem4.data, testdata, 4);
   }

   { static const OSOCTET testdata[] = {
   0xad, 0xcf, 0x62, 0xa4, 0x8, 0xd1, 0x7a, 0x7b,
   0x95, 0xb, 0x4f, 0x83, 0xd3, 0xf, 0x46, 0xe1,
   0x8f, 0x7a, 0xb6, 0x49, 0x42, 0xf6, 0x29, 0xd0,
   0xd0, 0x85, 0x45, 0x3a, 0x9a, 0x66, 0x76, 0x8,
   0xfa, 0xa0, 0x94, 0x26, 0x9e, 0x18, 0x7e, 0x97,
   0x50, 0x2e, 0x5, 0x55, 0xa7 };
   pvalue->c1.icon.numocts = 45;
   pvalue->c1.icon.data = (OSOCTET *)testdata;
   }

   pvalue->c1.name.value = OSUTF8("pvalue->c1.name");
   pvalue->c1.name.cdata = FALSE;

   { static const OSOCTET testdata[] = {
   0x13, 0xdd, 0x37, 0xee, 0x67, 0x18, 0x1a, 0xfe,
   0xd7, 0x16, 0x92, 0x89, 0x70, 0x54, 0x94, 0x3a,
   0x61, 0xf5, 0xdf, 0x98, 0x8a, 0xb3, 0x8a, 0xeb,
   0x27, 0x5f, 0x32, 0xce, 0x60, 0xd4, 0x18, 0xce,
   0xc0, 0x99, 0xf1, 0x27, 0xd4, 0x94, 0x30, 0xe9,
   0xfb, 0xa4, 0xf5, 0x2e, 0xaf, 0x65, 0x1a };
   pvalue->c2.hexBinElem.numocts = 47;
   pvalue->c2.hexBinElem.data = (OSOCTET *)testdata;
   }

   { static const OSOCTET testdata[] = {
   0x17, 0xb8, 0x13, 0xdf };
   pvalue->c2.hexBinElem4.numocts = 4;
   OSCRTLMEMCPY (pvalue->c2.hexBinElem4.data, testdata, 4);
   }

   { static const OSOCTET testdata[] = {
   0x2c, 0x32, 0x3e, 0x9e, 0x9b, 0x7f, 0x5d, 0x28,
   0xcf, 0x57, 0xc0, 0x64, 0x8b, 0x3, 0x1f, 0xa7,
   0x13 };
   pvalue->c2.icon.numocts = 17;
   pvalue->c2.icon.data = (OSOCTET *)testdata;
   }

   pvalue->c2.name.value = OSUTF8("pvalue->c2.name");
   pvalue->c2.name.cdata = FALSE;

   return (pvalue);
}

